﻿local addonName, QD = ...; -- gets addon-local variables

----------------------------------------------------------------------------------------------------
-- Hooking and modifying GetColoredName

-- Blizzards function for coloring names
-- GetColoredName(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12)
local hooked_GetColoredName = GetColoredName;
function GetColoredName(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12)
    local coloredName = hooked_GetColoredName( event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 );

    if ( QD.on  and ( QD.colorNames or QD.colorLines) ) then -- if interest colors shall be used
        -- if ( event == "CHAT_MSG_SAY" or event=="CHAT_MSG_TEXT_EMOTE" or event=="CHAT_MSG_EMOTE") then
        if ( QD.ChatChannel_IsUsed(event) ) then
            local color = QD.Color_GetChatColor(arg2);

            if (string.match(arg2, ".+-"..GetRealmName()) ~= nil) then
                arg2 = string.gsub(arg2, "-"..GetRealmName(), "")
            end
            
            if (color and color ~= "") then -- check correct user
                -- insert color
                coloredName = "\124cff"..color..QD.preText..arg2..QD.postText.."\124r";
            else
                -- no color if not of interest
                coloredName = arg2;
            end
        end
    end

    return coloredName;
end


-- Blizzards function for handling events, coloring the whole chatlines
-- ChatFrame_MessageEventHandler(self, event, ...)
local hooked_ChatFrame_MessageEventHandler = ChatFrame_MessageEventHandler; --(self, event, ...)
function ChatFrame_MessageEventHandler(self, event, ...)

    local _, arg2_NameWithRealm, _, arg4_Name = ...;
    local channelType = strsub(event, 10);
    local info = ChatTypeInfo[channelType];
    
    local oldR,oldG,oldB = 0,0,0; -- stores old line color

    if ( QD.on and QD.colorLines and QD.ChatChannel_IsTypeUsed( channelType ) and QD.vips[arg2_NameWithRealm]) then
        local hexColor = QD.Color_GetChatColor( arg2_NameWithRealm );
        local r,g,b = QuiDicit.HexToRGBPerc(hexColor);
        oldR, oldG, oldB = info.r, info.g, info.b;
        info.r = r;
        info.g = g;
        info.b = b;
    end

    hooked_ChatFrame_MessageEventHandler(self, event, ...);

    if ( QD.on and QD.colorLines and QD.ChatChannel_IsTypeUsed( channelType ) and QD.vips[arg2_NameWithRealm]) then
        -- set colors back to original
        info.r, info.g, info.b = oldR, oldG, oldB;
    end
end