﻿local addonName, QD = ...; -- gets addon-local variables

local L = QD.LOCALIZATION;
local act = QD.actionID;


----------------------------------------------------------------------------------------------------
-- ChatMenu

function QuiDicit.ChatMenu_OnLoad(self)
    -- add to main menu
    UIMenu_AddButton(ChatMenu, "QuiDicit", nil, nil, "QuiDicitChatMenu"); -- main menu

    -- build chat menu menu
    UIMenu_Initialize(QuiDicitChatMenu);
    QuiDicitChatMenu.parentMenu="ChatMenu";
    UIMenu_AddButton(QuiDicitChatMenu, "|cFFFFFFFF"..L.menu.MENU_GROUP.."|r", nil);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_GROUPCREATE, nil, QD.ChatMenu_Click,nil,act.GROUPCREATE);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_GROUPCOLOR.." >", nil, nil,"QuiDicitChatMenuGroup",act.GROUPCOLOR);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_GROUPCLEAR.." >", nil, nil,"QuiDicitChatMenuGroup",act.GROUPCLEAR);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_GROUPDELETE.." >", nil, nil,"QuiDicitChatMenuGroup",act.GROUPDELETE);
    UIMenu_AddButton(QuiDicitChatMenu, "|cFFFFFFFF"..L.menu.MENU_CHAR.."/"..L.menu.MENU_TARGET.."|r", nil);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_CHARCOLOR, nil, QD.ChatMenu_Click,nil,act.CHARCOLOR);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_CHARGROUP.." >", nil, nil,"QuiDicitChatMenuGroup",act.CHARGROUP);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_CHARUNCOLOR, nil, QD.ChatMenu_Click,nil,act.CHARUNCOLOR);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_CHARUNGROUP, nil, QD.ChatMenu_Click,nil,act.CHARUNGROUP);
    UIMenu_AddButton(QuiDicitChatMenu, "    "..L.menu.MENU_CHARDELETE, nil, QD.ChatMenu_Click,nil,act.CHARDELETE);
    UIMenu_AddButton(QuiDicitChatMenu, L.menu.MENU_OPTIONS .. " >", nil, nil,"QuiDicitChatMenuOptions",act.OPTIONS);
    UIMenu_AutoSize(QuiDicitChatMenu);

    -- override event settings
    QuiDicitChatMenuButton3:SetScript ("OnEnter", QD.ChatMenu_UpdateGroups);
    QuiDicitChatMenuButton4:SetScript ("OnEnter", QD.ChatMenu_UpdateGroups);
    QuiDicitChatMenuButton5:SetScript ("OnEnter", QD.ChatMenu_UpdateGroups);
    QuiDicitChatMenuButton8:SetScript ("OnEnter", QD.ChatMenu_UpdateGroups);
    QuiDicitChatMenuButton12:SetScript("OnEnter", QD.ChatMenu_UpdateOptions);
end

function QuiDicit.ChatMenu_OnLoadGroup(self)
    -- build group menu
    UIMenu_Initialize(self);
    self.parentMenu="QuiDicitChatMenu";
    self:Hide();
end

function QuiDicit.ChatMenu_OnLoadOptions(self)
    -- build options menu
    UIMenu_Initialize(self);
    self.parentMenu="QuiDicitChatMenu";
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickOptions, nil, act.TOGGLEONOFF);
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickOptions, nil, act.TOGGLECOLORNAMES);
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickOptions, nil, act.TOGGLECOLORLINES);
    UIMenu_AddButton(self, L.menu.MENU_SHOWCOLORS, nil, QD.ChatMenu_ClickOptions, nil, act.SHOWCOLORS);

    -- UIMenu_AddButton(self, "Pretext", nil, QD.ChatMenu_ClickOptions, nil, 0);
    -- UIMenu_AddButton(self, "Posttext", nil, QD.ChatMenu_ClickOptions, nil, );
    -- UIMenu_AddButton(self, "|cFFFFFFFF"..L.menu.MENU_PRIORITY.."|r", nil);
    -- UIMenu_AddButton(self, "  ", nil, QD.ChatMenu_ClickOptions, nil, 0);
    -- UIMenu_AddButton(self, "  ", nil, QD.ChatMenu_ClickOptions, nil, 0);
    UIMenu_AddButton(self, "|cFFFFFFFF"..L.menu.MENU_CHANNELS.."|r", nil);
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "SAY");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "YELL");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "EMOTE");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "PARTY");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "RAID");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "BATTLEGROUND");
    UIMenu_AddButton(self, "", nil, QD.ChatMenu_ClickChannels, nil, "GUILD");
    UIMenu_AutoSize(self);
    self:Hide();
end

function QD.ChatMenu_UpdateGroups(self)
    local src = self.value;
    QuiDicitChatMenuGroup:SetParent(self);
    QD.ChatMenu_BuildGroupMenu( src );
    local menu = QuiDicitChatMenuGroup;
    menu:ClearAllPoints();
    menu:SetPoint("BOTTOMLEFT", self, "BOTTOMRIGHT", 10, -12);

    UIMenuButton_OnEnter(self);
end

function QD.ChatMenu_UpdateOptions(self)
    -- Update menu texts
    QuiDicitChatMenuOptionsButton1:SetText(addonName .. " "  .. QD.Core_GetOnOffText(QD.on));
    QuiDicitChatMenuOptionsButton2:SetText(L.menu.MENU_ONOFFCOLORNAME  .. " " .. QD.Core_GetOnOffText(QD.colorNames));
    QuiDicitChatMenuOptionsButton3:SetText(L.menu.MENU_ONOFFCOLORLINE  .. " " ..  QD.Core_GetOnOffText(QD.colorLines));
    for i=6, 12 do
        local button = _G["QuiDicitChatMenuOptionsButton"..i];
        button:SetText("    "..button.value  .. " " ..  QD.Core_GetOnOffText(QD.usedChannels[button.value]));
    end
    UIMenu_AutoSize(QuiDicitChatMenuOptions);

    UIMenuButton_OnEnter(self);
end

function QD.ChatMenu_BuildGroupMenu( action )
    UIMenu_Initialize(QuiDicitChatMenuGroup);
    -- Header
    local title = "Action";
    if ( action == act.CHARGROUP ) then
        title = L.menu.MENU_CHARGROUP;

    elseif ( action == act.GROUPCOLOR ) then
        title = L.menu.MENU_GROUPCOLOR;

    elseif ( action == act.GROUPCLEAR ) then
        title = L.menu.MENU_GROUPCLEAR;

    elseif ( action == act.GROUPDELETE ) then
        title = L.menu.MENU_GROUPDELETE;

    end
    UIMenu_AddButton(QuiDicitChatMenuGroup, "|cFFFFFFFF"..title.."|r", nil);
    -- QuiDicitChatMenuGroupButton1:SetText( "|cFFFFFFFF"..title.."|r" );

    -- New Group
    if ( action == act.CHARGROUP ) then
        UIMenu_AddButton(QuiDicitChatMenuGroup, "@ "..L.menu.MENU_GROUPNEW, nil, QD.ChatMenu_Click,nil,action);
    end

    -- Group list
    local count = 1;
    for k,v in pairs (QD.vigs) do
        local colored = "";
        if ( v.color ~= "" ) then
            colored = "|cFF" .. v.color .. "\64|r ";
        end
        if ( count < 31 ) then
            UIMenu_AddButton(QuiDicitChatMenuGroup, colored .. k, nil, QD.ChatMenu_Click,nil,action);
        end
        count = count + 1;
    end

    UIMenu_AutoSize(QuiDicitChatMenuGroup);
	--QuiDicitChatMenuGroup:Hide();
end

function QD.ChatMenu_Click(self)
    -- get info about name, group and their colors
    local name,_ = UnitName("target")
    local color = "";
    local group = "";
    local groupcolor = "";
    name = name or "";

    -- check color and group
    if (QD.vips[name] ) then
        color = QD.vips[name].color;
        group = QD.vips[name].group;
    end
    color = color ~= "" and color or "ffffff";
    group = group ~= "" and group or "";

    -- check group color
    if (QD.vigs[group] ) then
        groupcolor = QD.vigs[group].color or "ffffff";
    end
    groupcolor = groupcolor ~= "" and groupcolor or "ffffff";

    -- local action = strtrim(self:GetText());
    local action = self.value;
    --QD.printDebug("Using: " .. L.menu.MENU_CHARCOLOR);
    if ( action == act.CHARCOLOR ) then
        QuiDicit.DialogColor_SetFields(action, name, group, color);
        QuiDicit.DialogColor_Unlock();
        QuiDicit.DialogColor_Setup( action );
        QuiDicit_DialogColor:Show();

    elseif ( action == act.CHARGROUP ) then
        local _, group = self:GetText():match("^(%S*)%s*(.-)$");
        if ( group ~= L.menu.MENU_GROUPNEW and name~="") then
            QD.Character_ChangeGroup(name, group);
            QD.printInfo(addonName .. ": " .. name .. " " ..L.info.MSG_CHANGE_GROUP .. " " .. group .. ".");
        elseif ( group ~= L.menu.MENU_GROUPNEW and name=="") then
            groupcolor = QD.vigs[group].color ~= "" and QD.vigs[group] and QD.vigs[group].color or "ffffff";
            QuiDicit.DialogColor_SetFields(action, name, group, groupcolor);
            QuiDicit.DialogColor_Unlock();
            QuiDicit.DialogColor_Setup( action );
            QuiDicit_DialogColor:Show();
        else
            QuiDicit.DialogColor_SetFields(action, name, "", color);
            QuiDicit.DialogColor_Unlock();
            QuiDicit.DialogColor_Setup( action );
            QuiDicit_DialogColor:Show();
        end

    elseif ( action == act.CHARUNCOLOR ) then
        if ( name == "" ) then
            QuiDicit.DialogColor_SetFields(action, name, "", color);
            QuiDicit.DialogColor_Unlock();
            QuiDicit.DialogColor_Setup( action );
            QuiDicit_DialogColor:Show();

        else
            QD.Character_ResetColor( name );
            QD.Character_Check();
            QD.printInfo(addonName .. ": " .. name .. " " .. L.info.MSG_RESET_COLOR);
        end

    elseif ( action == act.CHARUNGROUP ) then
        if ( name == "" ) then
            QuiDicit.DialogColor_SetFields(action, name, "", color);
            QuiDicit.DialogColor_Unlock();
            QuiDicit.DialogColor_Setup( action );
            QuiDicit_DialogColor:Show();

        else
            QD.Character_ResetGroup( name );
            QD.Character_Check();
            QD.printInfo(addonName .. ": " .. name .. " " .. L.info.MSG_RESET_GROUP);
        end

    elseif ( action == act.CHARDELETE ) then
        if ( name == "" ) then
            QuiDicit.DialogColor_SetFields(action, name, "", color);
            QuiDicit.DialogColor_Unlock();
            QuiDicit.DialogColor_Setup( action );
            QuiDicit_DialogColor:Show();
        else
            QD.Character_Remove( name );
            QD.printInfo(addonName .. ": ".. name .. " ".. L.info.MSG_REMOVED_VI);
        end

    elseif ( action == act.GROUPCREATE ) then
        QuiDicit.DialogColor_SetFields(action, "", "", "ffffff");
        QuiDicit.DialogColor_Unlock();
        QuiDicit.DialogColor_Setup( action );
        QuiDicit_DialogColor:Show();

    elseif ( action == act.GROUPCOLOR ) then
        local _, group = self:GetText():match("^(%S*)%s*(.-)$");
        color = QD.vigs[group].color or color;
        QuiDicit.DialogColor_SetFields(action, "", group, color);
        QuiDicit.DialogColor_Unlock();
        QuiDicit.DialogColor_Setup( action );
        QuiDicit_DialogColor:Show();

    elseif ( action == act.GROUPCLEAR ) then
        local _, group = self:GetText():match("^(%S*)%s*(.-)$");
        QD.Group_Clear( group );
        QD.printInfo(addonName .. ": " .. group .. " " .. L.info.MSG_GROUPCLEAR);

    elseif ( action == act.GROUPDELETE ) then
        local _, group = self:GetText():match("^(%S*)%s*(.-)$");
        QD.Group_Remove( group );
        QD.printInfo(addonName .. ": ".. group .." ".. L.info.MSG_REMOVED_VI);

    end
    QD.Character_Check();
    QD.ChatMenu_Hide();
end

function QD.ChatMenu_ClickGroups(self)

end

function QD.ChatMenu_ClickOptions(self)
    local action = self.value;
    if ( action == act.TOGGLEONOFF ) then
        QD.Core_ToggleOnOff( nil, true );

    elseif ( action == act.TOGGLECOLORNAMES ) then
        QD.Core_ToggleNames( nil, true );

    elseif ( action == act.TOGGLECOLORLINES ) then
        QD.Core_ToggleLines( nil, true );

    elseif ( action == act.SHOWCOLORS ) then
        QD.Core_PrintColors();

    end

    QD.ChatMenu_Hide();
end

function QD.ChatMenu_ClickChannels(self)
    local channel = self.value;
    QD.ChatChannel_ToggleChannel ( channel, nil, true );
    QD.ChatMenu_Hide();
end

function QD.ChatMenu_ClickPriority(self)

end

function QD.ChatMenu_Hide()
    ChatMenu:Hide();
    QuiDicitChatMenu:Hide();
    QuiDicitChatMenuGroup:Hide();
    QuiDicitChatMenuOptions:Hide();
end



-- -- ----------------------------------------------------------------------------------------------------
-- -- -- Context menu at target or name in chat

-- local PopupMenu = {
    -- text = "QuiDicit",
    -- value = "42",
    -- notCheckable = 1,
    -- func = function()
        -- print("Popupbutton 1");
    -- end;
    -- hasArrow = true,
    -- menuList = {
        -- { text = "Submenu", isTitle = true},
        -- { text = "A1", QuiDicit.Popup_OnClick },
        -- { text = "A2", QuiDicit.Popup_OnClick },
    -- }
-- };

-- local submenus = {
    -- ["Level1"] = {
        -- text = "ColorMe",
        -- value = "21",
        -- notCheckable = 1,
        -- func = QuiDicit.Popup_OnClick,
    -- },
    -- ["Level2"] = {
        -- text = "GroupMe",
        -- value = "22",
        -- notCheckable = 1,
        -- func = QuiDicit.Popup_OnClick,
    -- }
-- }

-- -- color, group, uncolor, ungroup, delete; grouplist
-- local popupTypes = { "SELF", "FRIEND", "TARGET", "FOCUS" };

function QuiDicit.Popup_OnLoad( self )
    -- hooksecurefunc("UnitPopup_ShowMenu", QuiDicit.Popup_UnitPopupOnShow);
    -- -- UIDropDownMenu_AddButton(PopupMenu);
end

-- function QuiDicit.Popup_UnitPopupOnShow(dropdownMenu, which, unit, name, userData)
    -- print(dropdownMenu:GetName() .. ", ".. tostring(which) .. ", ".. tostring(unit) .. ", ".. tostring(name) .. ", ".. tostring(userData));
    -- if (true--InCombatLockdown() == nil 
            -- and ( tContains(popupTypes,which))) then
        -- if ( UIDROPDOWNMENU_MENU_LEVEL == 1 ) then
            -- UIDropDownMenu_AddButton(PopupMenu); -- adds main popup
        -- -- elseif ( UIDROPDOWNMENI_MENU_LEVEL == 2 ) then
            -- --UIDropDownMenu_AddButton(PopupMenu);
        -- end
    -- end
-- end

-- function QuiDicit.Popup_OnClick(self)
    -- print("clicked " .. self:GetName() .. " with " .. self:GetValue());
-- end


                
-- function QD.initPopups()
    -- -- UnitPopupButtons["QUIDICIT"] = { text = "QuiDicit", dist = 0 };
    -- -- tinsert(UnitPopupMenus["SELF"],"QUIDICIT");
    -- --/script UnitPopupButtons["QUIDICIT"] = { text = "QuiDicit", dist = 0 };tinsert(UnitPopupMenus["FRIEND"],"QUIDICIT");

    -- DEFAULT_CHAT_FRAME:AddMessage( "hallo welt", 1.0,0.0,0.0);
-- end

-- local hooked = UnitPopup_OnClick;
-- function UnitPopup_OnClick ( self )

    -- DEFAULT_CHAT_FRAME:AddMessage( "hallo welt", 1.0,0.0,0.0);
    -- hooked(self);
-- end

-- local hook1 = UnitPopup_OnClick;
-- function UnitPopup_OnClick (self)
    -- QD_TMP = self;
    -- DEFAULT_CHAT_FRAME:AddMessage( "hallo welt", 0.5, 0.5, 0.5);
    -- --QD.printDebug("Clicked: ".. self.button);
    -- hook1(self);
-- end

-- local hook2 = UnitPopup_OnUpdate (elapsed);
-- function UnitPopup_OnUpdate (elapsed)
    -- QD.printDebug("onupdate");
    -- hook2(elapsed);
-- end

-- local hook3 = UnitPopup_HideButtons;
-- function UnitPopup_HideButtons ()
    -- QD.printDebug("hidebuttons");
    -- hook3();
-- end

-- local hook4 = UnitPopup_ShowMenu;
-- function UnitPopup_ShowMenu (dropdownMenu, which, unit, name, userData)
    -- QD.printDebug("showmenu");
    -- hook4(dropdownMenu, which, unit, name, userData);
-- end